/* Module exec_startup */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#define EXPORT_BOOLEAN
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/mig_support.h>

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	mig_external
#define mig_external
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#define	UseExternRCSId		1
#endif

#define msgh_request_port	msgh_local_port
#define MACH_MSGH_BITS_REQUEST(bits)	MACH_MSGH_BITS_LOCAL(bits)
#define msgh_reply_port		msgh_remote_port
#define MACH_MSGH_BITS_REPLY(bits)	MACH_MSGH_BITS_REMOTE(bits)

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <device/device_types.h>
#include <device/net_status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <hurd/hurd_types.h>

/* Routine exec_startup_get_info */
mig_internal void _Xexec_startup_get_info
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
		mach_msg_type_t user_entryType;
		vm_address_t user_entry;
		mach_msg_type_t phdr_dataType;
		vm_address_t phdr_data;
		mach_msg_type_t phdr_sizeType;
		vm_size_t phdr_size;
		mach_msg_type_t stack_baseType;
		vm_address_t stack_base;
		mach_msg_type_t stack_sizeType;
		vm_size_t stack_size;
		mach_msg_type_t flagsType;
		int flags;
		mach_msg_type_long_t argvType;
		char argv[2048];
		mach_msg_type_long_t envpType;
		char envp[2048];
		mach_msg_type_long_t dtableType;
		mach_port_t dtable[512];
		mach_msg_type_long_t portarrayType;
		mach_port_t portarray[512];
		mach_msg_type_long_t intarrayType;
		int intarray[512];
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_exec_startup_get_info
		(mach_port_t bootstrap, vm_address_t *user_entry, vm_address_t *phdr_data, vm_size_t *phdr_size, vm_address_t *stack_base, vm_size_t *stack_size, int *flags, data_t *argv, mach_msg_type_number_t *argvCnt, data_t *envp, mach_msg_type_number_t *envpCnt, portarray_t *dtable, mach_msg_type_name_t *dtablePoly, mach_msg_type_number_t *dtableCnt, portarray_t *portarray, mach_msg_type_name_t *portarrayPoly, mach_msg_type_number_t *portarrayCnt, intarray_t *intarray, mach_msg_type_number_t *intarrayCnt);

	boolean_t msgh_simple;
	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_t user_entryType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t phdr_dataType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t phdr_sizeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t stack_baseType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t stack_sizeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t flagsType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_long_t argvType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	8,
		/* msgtl_size = */	8,
		/* msgtl_number = */	2048,
	};

	static const mach_msg_type_long_t envpType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	8,
		/* msgtl_size = */	8,
		/* msgtl_number = */	2048,
	};

	static const mach_msg_type_long_t dtableType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	-1,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t portarrayType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	-1,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t intarrayType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	mach_msg_type_number_t argvCnt;
	char envp[2048];
	mach_msg_type_number_t envpCnt;
	mach_port_t dtable[512];
	mach_msg_type_name_t dtablePoly;
	mach_msg_type_number_t dtableCnt;
	mach_port_t portarray[512];
	mach_msg_type_name_t portarrayPoly;
	mach_msg_type_number_t portarrayCnt;
	int intarray[512];
	mach_msg_type_number_t intarrayCnt;

	char *argvP;
	char *envpP;
	mach_port_t *dtableP;
	mach_port_t *portarrayP;
	int *intarrayP;

#if	TypeCheck
	if ((In0P->Head.msgh_size != 24) ||
	    (In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	argvP = OutP->argv;
	argvCnt = 2048;

	envpP = envp;
	envpCnt = 2048;

	dtableP = dtable;
	dtableCnt = 512;

	portarrayP = portarray;
	portarrayCnt = 512;

	intarrayP = intarray;
	intarrayCnt = 512;

	OutP->RetCode = S_exec_startup_get_info(In0P->Head.msgh_request_port, &OutP->user_entry, &OutP->phdr_data, &OutP->phdr_size, &OutP->stack_base, &OutP->stack_size, &OutP->flags, &argvP, &argvCnt, &envpP, &envpCnt, &dtableP, &dtablePoly, &dtableCnt, &portarrayP, &portarrayPoly, &portarrayCnt, &intarrayP, &intarrayCnt);
	if (OutP->RetCode != KERN_SUCCESS)
		return;

	msgh_simple = TRUE;

	OutP->user_entryType = user_entryType;

	OutP->phdr_dataType = phdr_dataType;

	OutP->phdr_sizeType = phdr_sizeType;

	OutP->stack_baseType = stack_baseType;

	OutP->stack_sizeType = stack_sizeType;

	OutP->flagsType = flagsType;

	OutP->argvType = argvType;
	if (argvP != OutP->argv) {
		OutP->argvType.msgtl_header.msgt_inline = FALSE;
		OutP->argvType.msgtl_header.msgt_deallocate = TRUE;
		*((char **)OutP->argv) = argvP;
		msgh_simple = FALSE;
	}

	OutP->argvType.msgtl_number = argvCnt;
	msgh_size_delta = (OutP->argvType.msgtl_header.msgt_inline) ? (argvCnt + 3) & ~3 : sizeof(char *);
	msgh_size = 140 + msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->envpType = envpType;

	if (envpP != envp) {
		OutP->envpType.msgtl_header.msgt_inline = FALSE;
		OutP->envpType.msgtl_header.msgt_deallocate = TRUE;
		*((char **)OutP->envp) = envpP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->envp, envp, envpCnt);
	}

	OutP->envpType.msgtl_number = envpCnt;
	msgh_size_delta = (OutP->envpType.msgtl_header.msgt_inline) ? (envpCnt + 3) & ~3 : sizeof(char *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->dtableType = dtableType;

	if (dtableP != dtable) {
		OutP->dtableType.msgtl_header.msgt_inline = FALSE;
		OutP->dtableType.msgtl_header.msgt_deallocate = TRUE;
		*((mach_port_t **)OutP->dtable) = dtableP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->dtable, dtable, 4 * dtableCnt);
	}

	if (MACH_MSG_TYPE_PORT_ANY(dtablePoly))
		msgh_simple = FALSE;

	OutP->dtableType.msgtl_name = dtablePoly;

	OutP->dtableType.msgtl_number = dtableCnt;
	msgh_size_delta = (OutP->dtableType.msgtl_header.msgt_inline) ? 4 * dtableCnt : sizeof(mach_port_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->portarrayType = portarrayType;

	if (portarrayP != portarray) {
		OutP->portarrayType.msgtl_header.msgt_inline = FALSE;
		OutP->portarrayType.msgtl_header.msgt_deallocate = TRUE;
		*((mach_port_t **)OutP->portarray) = portarrayP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->portarray, portarray, 4 * portarrayCnt);
	}

	if (MACH_MSG_TYPE_PORT_ANY(portarrayPoly))
		msgh_simple = FALSE;

	OutP->portarrayType.msgtl_name = portarrayPoly;

	OutP->portarrayType.msgtl_number = portarrayCnt;
	msgh_size_delta = (OutP->portarrayType.msgtl_header.msgt_inline) ? 4 * portarrayCnt : sizeof(mach_port_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->intarrayType = intarrayType;

	if (intarrayP != intarray) {
		OutP->intarrayType.msgtl_header.msgt_inline = FALSE;
		OutP->intarrayType.msgtl_header.msgt_deallocate = TRUE;
		*((int **)OutP->intarray) = intarrayP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->intarray, intarray, 4 * intarrayCnt);
	}

	OutP->intarrayType.msgtl_number = intarrayCnt;
	msgh_size += (OutP->intarrayType.msgtl_header.msgt_inline) ? 4 * intarrayCnt : sizeof(int *);

	OutP = (Reply *) OutHeadP;
	if (!msgh_simple)
		OutP->Head.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
	OutP->Head.msgh_size = msgh_size;
}

static mig_routine_t exec_startup_server_routines[] = {
		_Xexec_startup_get_info,
};

mig_external boolean_t exec_startup_server
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	register mach_msg_header_t *InP =  InHeadP;
	register mig_reply_header_t *OutP = (mig_reply_header_t *) OutHeadP;

	static const mach_msg_type_t RetCodeType = {
		/* msgt_name = */		MACH_MSG_TYPE_INTEGER_32,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	register mig_routine_t routine;

	OutP->Head.msgh_bits = MACH_MSGH_BITS(MACH_MSGH_BITS_REPLY(InP->msgh_bits), 0);
	OutP->Head.msgh_size = sizeof *OutP;
	OutP->Head.msgh_remote_port = InP->msgh_reply_port;
	OutP->Head.msgh_local_port = MACH_PORT_NULL;
	OutP->Head.msgh_seqno = 0;
	OutP->Head.msgh_id = InP->msgh_id + 100;

	OutP->RetCodeType = RetCodeType;

	if ((InP->msgh_id > 30500) || (InP->msgh_id < 30500) ||
	    ((routine = exec_startup_server_routines[InP->msgh_id - 30500]) == 0)) {
		OutP->RetCode = MIG_BAD_ID;
		return FALSE;
	}
	(*routine) (InP, &OutP->Head);
	return TRUE;
}

mig_external mig_routine_t exec_startup_server_routine
	(const mach_msg_header_t *InHeadP)
{
	register int msgh_id;

	msgh_id = InHeadP->msgh_id - 30500;

	if ((msgh_id > 0) || (msgh_id < 0))
		return 0;

	return exec_startup_server_routines[msgh_id];
}

